routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



Auth::routes();


Route::get('/', function () {
    // return view('welcome');
    return redirect('/login');
    // return config('app.ref_db');
});

Route::get('change_password', 'Auth\ChangePasswordController@showChangePasswordForm')->name('auth.change_password');
Route::patch('change_password', 'Auth\ChangePasswordController@changePassword')->name('auth.change_password');


Route::middleware(['auth'])->group(function () {
    //
    Route::get('/home', 'HomeController@index')->name('home');

    Route::resource('role', 'RoleController');
    Route::get('role/{role}/hapus', 'RoleController@destroy')->name('role.hapus');
    Route::resource('permission', 'PermissionController');
    Route::get('permission/{role}/hapus', 'PermissionController@destroy')->name('permission.hapus');
    Route::resource('account', 'PenggunaController')->only(['index', 'edit', 'update']);

    Route::resource('pegawai', 'PegawaiController')->except(['destroy']);
    Route::get('pegawai/{role}/hapus', 'PegawaiController@destroy')->name('pegawai.hapus');
    Route::get('apbdes', 'AnggaranController@index')->name('apbdes');
    Route::get('bop', 'AnggaranController@ProyeksiBop')->name('bop');
    Route::get('bop/pdf', 'AnggaranController@ProyeksiBopPdf')->name('bop.pdf');
    Route::get('belanjafisik', 'AnggaranController@belanjaFisik')->name('belanjafisik');
    Route::get('belanjafisik/pdf', 'AnggaranController@belanjaFisikpdf')->name('belanjafisik.pdf');
    Route::get('panjardd', 'AnggaranController@panjarFisikDanaDesa')->name('panjardd');
    Route::get('panjardd/pdf', 'AnggaranController@panjarFisikDanaDesaPdf')->name('panjardd.pdf');
    Route::get('pajak', 'AnggaranController@SektorPajak')->name('pajak');
    Route::get('pajak/pdf', 'AnggaranController@SektorPajakPdf')->name('pajak.pdf');

    Route::resource('pembinaan', 'PembinaanController')->except(['destroy']);
    Route::get('pembinaan/{pembinaan}/hapus', 'PembinaanController@destroy')->name('pembinaan.hapus');
    Route::post('pembinaan/upload', 'PembinaanController@uploadData')->name('pembinaan.upload');


    Route::resource('pembinaanevaluasi', 'pembinaanevaluasiController')->except(['destroy']);
    Route::get('pembinaanevaluasi/{pembinaanevaluasi}/hapus', 'pembinaanevaluasiController@destroy')->name('pembinaanevaluasi.hapus');
    Route::post('pembinaanevaluasi/upload', 'pembinaanevaluasiController@uploadData')->name('pembinaanevaluasi.upload');

    Route::resource('pengawasan', 'PengawasanController')->except(['destroy']);
    Route::get('pengawasan/{pengawasan}/hapus', 'PengawasanController@destroy')->name('pengawasan.hapus');
    Route::post('pengawasan/upload', 'PengawasanController@uploadData')->name('pengawasan.upload');


    Route::resource('pengaduan', 'PengaduanController')->except(['destroy']);
    Route::get('pengaduan/{pengaduan}/hapus', 'PengaduanController@destroy')->name('pengaduan.hapus');
    Route::post('pengaduan/upload', 'PengaduanController@uploadData')->name('pengaduan.upload');

    Route::resource('perintah', 'PerintahPengawasanController')->except(['destroy']);
    Route::get('perintah/{perintah}/hapus', 'PerintahPengawasanController@destroy')->name('perintah.hapus');
    Route::get('perintah/selesai/{perintah}', 'PerintahPengawasanController@selesaiCtrl')->name('perintah.selesai');
    Route::get('resiko', 'FaktorResikoController@index')->name('resiko');
    Route::get('resiko/refresh', 'FaktorResikoController@refreshData')->name('resiko.refresh');
    Route::get('resiko/pdf', 'FaktorResikoController@indexPdf')->name('resiko.pdf');

    Route::get('kecamatan', 'WilayahController@kecamatan')->name('kecamatan');
    Route::get('desa', 'WilayahController@desa')->name('desa');

    Route::get('keuangan', 'KeuanganController@index')->name('keuangan');
});

app/Http/Controllers/PermissionController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use Yajra\Datatables\Datatables;
use DB;

class PermissionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if (!userCan('permissions.list')) {
            \abort(403, 'Anda tidak memiliki hak ases');
        }
        if ($request->ajax()) {
            $permission = Permission::query();
            return Datatables::of($permission)
                ->order(function ($query) {
                        $query->orderBy('id', 'desc');
                })
                ->addColumn('action', function ($permission) {
                    $btn = '<a href="' . route('permission.edit', $permission->id) . '" class="btn btn-xs btn-primary"><i class="material-icons">edit</i></a>';
                    $btn .= '<a href="#"   data-url="' . route('permission.hapus', $permission->id) . '" class="hapus btn btn-xs btn-danger"><i class="material-icons">delete</i></a>';
                    return $btn;
                })
                ->make(true);
        }
        return view('Permission.Index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if (!userCan('permissions.create')) {
            \abort(403, 'Anda tidak memiliki hak ases');
        }
        $data = [
            'action' => route('permission.store'),
            'method' => 'POST',
            'role' => Role::all()
        ];

        return view('Permission.form', \compact('data'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if (!userCan('permissions.create')) {
            \abort(403, 'Anda tidak memiliki hak ases');
        }
        DB::beginTransaction();
        try {

            $vr = $request->role;
            $permission = Permission::create(['name' => $request->permission]);
            foreach ($vr as $vr) {
                $role = Role::where('name', $vr)->first();
                $role->givePermissionTo($permission);
                $permission->assignRole($role);
            }
            $pesan = "berhasil di tambahkan";
            $type = "success";
            DB::commit();
        } catch (\Exception $e) {
            DB::rollback();
            $pesan = $e->getMessage();
            $type = "warning";
        }

        return redirect()->route('permission.index')->with(['pesan' => $pesan, 'type' => $type]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        if (!userCan('permissions.edit')) {
            \abort(403, 'Anda tidak memiliki hak ases');
        }
        $permission = Permission::find($id);
        $data = [
            'action' => route('permission.update', $id),
            'method' => 'PATCH',
            'role' => Role::get(),
            'permission' => $permission
        ];
        return view('Permission.form', \compact('data'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if (!userCan('permissions.edit')) {
            \abort(403, 'Anda tidak memiliki hak ases');
        }
        DB::beginTransaction();
        try {
            $permission = Permission::find($id);
            $permission->name = $request->permission;
            $permission->save();


            // revoke role
            $rr = Role::get();
            foreach ($rr as $rr) {
                $rr->revokePermissionTo($permission->name);
            }


            $vr = $request->role;
            foreach ($vr as $vr) {
                $role = Role::where('name', $vr)->first();
                $role->givePermissionTo($permission);
                $permission->assignRole($role);
            }
            $pesan = "berhasil di update";
            $type = "success";
            DB::commit();
        } catch (\Exception $e) {
            DB::rollback();
            $pesan = $e->getMessage();
            $type = "warning";
            // return false;
        }

        return redirect()->route('permission.index')->with(['pesan' => $pesan, 'type' => $type]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        if (!userCan('permissions.delete')) {
            \abort(403, 'Anda tidak memiliki hak ases');
        }
        $permission = Permission::find($id);
        $permission->delete();
        // dd($id);
        return redirect()->route('permission.index')->with(['pesan' => "data telah di hapus", 'type' => 'success']);
    }
}

resources/views/Permission/Index.blade.php
@extends('layouts.admin')
@section('title')
<h2>PERMISSIONS
    <div class="pull-right">
        <a href="{{ route('permission.create') }}" class="btn btn-xs btn-primary"><i class="material-icons">note_add</i> Tambah</a>
    </div>
</h2>
@endsection
@section('content')

<div class="row clearfix">
    <div class="col-lg-12">
        <div class="card">
            <div class=" body">
                <div class="table-responsive">
                    <table class="table table-striped" id="table">
                        <thead class="bg-success text-white ">
                            <tr>
                                <th width="10px">No</th>
                                <th>Permission Name</th>
                                <th>Role </th>
                                <th width="120px"></th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>


    </div>
</div>


@endsection
@section('script')
<script>
    $(document).ready(function() {
        // console.log("ready!");
        $('#table').DataTable({
            processing: true,
            serverSide: false,
            ordering: false,
            ajax: "{{ url('/permission') }}",
            columns: [{
                    data: 'id',
                    name: 'id'
                },
                {
                    data: 'name',
                    name: 'name'
                },
                {
                    data: 'guard_name',
                    name: 'guard_name'
                },
                {
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false,
                    className: "text-center",
                },

            ],
            fnCreatedRow: function(row, data, index) {
                $('td', row).eq(0).html(index + 1);
            }

        });
    });
</script>
@endsection

resources/views/Permission/form.blade.php
@extends('layouts.admin')
@section('title')
<h2>FORM PERMISSIONS</h2>
@endsection
@section('content')

<div class="row clearfix">
    <div class="col-lg-12">
        <div class="card">
            <div class="body">
                <form action="{{ $data['action'] }}" method="POST">
                    {{ csrf_field() }}
                    {{ method_field($data['method']) }}
                    <div class="row">
                        <div class="col-md-3">
                            <div class="form-group">
                                <label>Permission</label>
                                <div class="form-line">
                                    <input type="text" name="permission" value="{{ $data['permission']->name??'' }}" id="permission" class="form-control" required>
                                </div>

                            </div>
                        </div>
                        <div class="col-md-9">
                            <label for="">Role</label>
                            <div class="row">
                                @foreach($data['role'] as $role)
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <div class="custom-control custom-checkbox mr-sm-2">
                                            <input @if(!empty($data['permission'])) @if($role->hasPermissionTo($data['permission']->name)) checked @endif @endif type="checkbox" class="custom-control-input" name="role[]" id="{{ $role->name }}" value="{{ $role->name }}">
                                            <label class="custom-control-label" for="{{ $role->name }}">{{ $role->name }}</label>
                                        </div>
                                    </div>
                                </div>
                                @endforeach
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <button class="btn btn-success" type="submit"><i class="material-icons">save</i> Simpan</button>
                        <a href="{{ url('permission') }}" class="btn btn-warning"><i class="material-icons">flip_to_back</i> Kembali</a>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>


@endsection